'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _react2 = require('@storybook/react');

var _index = require('../index');

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _index2 = require('./index');

var _index3 = _interopRequireDefault(_index2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var IngressEgress = (0, _index.chartAsReactComponent)(_index3.default);

function generateRandomMillisecondPosition() {
  var time = Math.floor(Math.random() * 50000) + 10000;
  return _moment2.default.utc().subtract(time, 'milliseconds');
}

function generateRandomCountChangeEvents() {
  var acc = [];
  for (var i = 0; i < Math.floor(Math.random() * 32); i++) {
    acc.push({
      countChange: Math.random() > 0.5 ? 1 : -1, // Pick a random direction
      timestamp: generateRandomMillisecondPosition() // and timestamp
    });
  }

  var data = acc.sort(function (a, b) {
    return a.timestamp - b.timestamp;
  });
  (0, _react2.action)('data')(data);
  return data;
}

(0, _react2.storiesOf)('Real Time Count', module).add('With a few set datapoints', function () {
  return React.createElement(IngressEgress, {
    events: [{ countChange: 1, timestamp: _moment2.default.utc() }, { countChange: 1, timestamp: _moment2.default.utc().subtract(6000, 'milliseconds') }, { countChange: 1, timestamp: _moment2.default.utc().subtract(12000, 'milliseconds') }, { countChange: 1, timestamp: _moment2.default.utc().subtract(40000, 'milliseconds') }, { countChange: -1, timestamp: _moment2.default.utc().subtract(42000, 'milliseconds') }]
  });
}).add('With a few set datapoints that should stack', function () {
  return React.createElement(IngressEgress, {
    events: [{ countChange: 1, timestamp: new Date().getTime() - 50000 }, { countChange: 1, timestamp: new Date().getTime() - 43402 }, { countChange: 1, timestamp: new Date().getTime() - 43401 }, { countChange: 1, timestamp: new Date().getTime() - 42001 }, { countChange: 1, timestamp: new Date().getTime() - 42000 }, { countChange: 1, timestamp: new Date().getTime() - 30000 }, { countChange: -1, timestamp: new Date().getTime() - 20000 }, { countChange: -1, timestamp: new Date().getTime() - 20500 }]
  });
}).add('With a bunch of random data', function () {
  return React.createElement(IngressEgress, { events: generateRandomCountChangeEvents() });
}).add('With a shorter duration (ie, 1 min)', function () {
  return React.createElement(IngressEgress, {
    events: [{ countChange: -1, timestamp: new Date().getTime() - 5000 }, { countChange: 1, timestamp: new Date().getTime() - 10000 }, { countChange: -1, timestamp: new Date().getTime() - 7500 }, { countChange: 1, timestamp: new Date().getTime() - 50000 }],
    graphDurationInMin: 1
  });
}).add('Live updates', function () {
  var Wrapper = function (_React$Component) {
    _inherits(Wrapper, _React$Component);

    function Wrapper(props) {
      _classCallCheck(this, Wrapper);

      var _this = _possibleConstructorReturn(this, (Wrapper.__proto__ || Object.getPrototypeOf(Wrapper)).call(this, props));

      _this.state = {
        data: [{ countChange: -1, timestamp: _moment2.default.utc() }],
        interval: setInterval(function () {
          this.setState({
            data: [].concat(_toConsumableArray(this.state.data), [{
              countChange: Math.random() > 0.5 ? 1 : -1, // Pick a random direction
              timestamp: new Date().getTime()
            }])
          });
        }.bind(_this), 1000)
      };
      return _this;
    }

    _createClass(Wrapper, [{
      key: 'componentWillUnmount',
      value: function componentWillUnmount() {
        clearInterval(this.state.interval);
      }
    }, {
      key: 'render',
      value: function render() {
        var _this2 = this;

        return React.createElement(
          'div',
          null,
          React.createElement(IngressEgress, { events: this.state.data }),
          React.createElement(
            'button',
            { onClick: function onClick() {
                return _this2.forceUpdate();
              } },
            'Update'
          )
        );
      }
    }]);

    return Wrapper;
  }(React.Component);

  return React.createElement(Wrapper, null);
});

